/*********************************************************************NVMH3****
File:  $Id: //sw/devtools/SDK/9.5/SDK/MEDIA/HLSL/pre_psych.fx#3 $

Copyright NVIDIA Corporation 2004
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
*AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:
    Put a texture behind the current scene
	Geometry Ignored

******************************************************************************/

#include <include\\Quad.fxh>

float Script : STANDARDSGLOBAL <
	string UIWidget = "none";
	string ScriptClass = "scene";
	string ScriptOrder = "preprocess";
	string ScriptOutput = "color";
	string Script = "Technique=TexBg;";
> = 0.8; // version #

float ClearDepth <string UIWidget = "none";> = 1.0;

float Timer : TIME < string UIWidget="none";>;

float S0 <
	string UIName = "Speed 0";
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 0.2;
	float UIStep = 0.01;
> = 0.01f;

float S1 <
	string UIName = "Speed 1";
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 0.2;
	float UIStep = 0.01;
> = 0.01f;

float S2 <
	string UIName = "Speed 2";
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 0.2;
	float UIStep = 0.01;
> = 0.01f;

float S3 <
	string UIName = "Speed 3";
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 0.2;
	float UIStep = 0.01;
> = 0.01f;

static float Off0 = (S0 * Timer);
static float Off1 = (S1 * Timer);
static float Off2 = (S2 * Timer);
static float Off3 = (S3 * Timer);

///////// Textures ///////////////

FILE_TEXTURE_2D(BgTex,BgSamp,"cloudmix.dds")
FILE_TEXTURE_2D(GrTex,GrSamp,"grad1.dds")

QUAD_REAL4 psychPS(QuadVertexOutput IN) : COLOR
{   
	QUAD_REAL4 texCol = tex2D(BgSamp, IN.UV);
	texCol.x = tex2D(GrSamp,float2(texCol.x+Off0,0)).x;
	texCol.y = tex2D(GrSamp,float2(texCol.y+Off1,0)).x;
	texCol.z = tex2D(GrSamp,float2(texCol.z+Off2,0)).x;
	// texCol.x = tex2D(GrSamp,float2(texCol.x+Off0,0));
	return texCol;
}  

////////////////////////

technique TexBg <
	string Script =
				"ClearSetDepth=ClearDepth;"
				"Clear=Depth;"
				"Pass=Bg;"
				"ScriptExternal=Scene;";
> {
	pass Bg <
		string Script = "Draw=Buffer;";
	> {
		VertexShader = compile vs_1_1 ScreenQuadVS();
		AlphaBlendEnable = false;
		ZEnable = false;
		PixelShader  = compile ps_2_a psychPS();
	}
}

/***************************** eof ***/
